OpenTTD Source: src/genworld_gui.cpp File Reference

OpenTTD Source 14.0-beta1

Data Structures | Enumerations | Functions | Variables
genworld_gui.cpp File Reference
`#include "stdafx.h"`
`#include "heightmap.h"`
`#include "debug.h"`
`#include "genworld.h"`
`#include "network/network.h"`
`#include "strings_func.h"`
`#include "window_func.h"`
`#include "timer/timer_game_calendar.h"`
`#include "sound_func.h"`
`#include "fios.h"`
`#include "string_func.h"`
`#include "widgets/dropdown_type.h"`
`#include "widgets/dropdown_func.h"`
`#include "querystring_gui.h"`
`#include "town.h"`
`#include "core/geometry_func.hpp"`
`#include "core/random_func.hpp"`
`#include "saveload/saveload.h"`
`#include "progress.h"`
`#include "error.h"`
`#include "newgrf_townname.h"`
`#include "townname_type.h"`
`#include "video/video_driver.hpp"`
`#include "ai/ai_gui.hpp"`
`#include "game/game_gui.hpp"`
`#include "industry.h"`
`#include "widgets/genworld_widget.h"`
`#include "safeguards.h"`

Go to the source code of this file.

## Data Structures
struct | GenerateLandscapeWindow
struct | CreateScenarioWindow
struct | GenWorldStatus
struct | GenerateProgressWindow

## Enumerations
enum | GenerateLandscapeWindowMode { GLWM_GENERATE, GLWM_HEIGHTMAP, GLWM_SCENARIO }
| Enum for the modes we can generate in. More...

## Functions
void | MakeNewgameSettingsLive ()
static uint | GetMapHeightLimit ()
| Get the map height limit, or if set to "auto", the absolute limit.
void | SetNewLandscapeType (byte landscape)
| Changes landscape type and sets genworld window dirty. More...
static void | StartGeneratingLandscape (GenerateLandscapeWindowMode mode)
static void | LandscapeGenerationCallback (Window *w, bool confirmed)
static DropDownList | BuildMapsizeDropDown ()
static DropDownList | BuildTownNameDropDown ()
static void | _ShowGenerateLandscape (GenerateLandscapeWindowMode mode)
void | ShowGenerateLandscape ()
| Start with a normal game.
void | ShowHeightmapLoad ()
| Start with loading a heightmap.
void | StartScenarioEditor ()
| Start with a scenario editor.
void | StartNewGameWithoutGUI (uint32_t seed)
| Start a normal game without the GUI. More...
void | ShowCreateScenario ()
| Show the window to create a scenario.
static void | AbortGeneratingWorldCallback (Window *, bool confirmed)
void | PrepareGenerateWorldProgress ()
| Initializes the progress counters to the starting point.
void | ShowGenerateWorldProgress ()
| Show the window where a user can follow the process of the map generation.
static void | _SetGeneratingWorldProgress (GenWorldProgress cls, uint progress, uint total)
void | SetGeneratingWorldProgress (GenWorldProgress cls, uint total)
| Set the total of a stage of the world generation. More...
void | IncreaseGeneratingWorldProgress (GenWorldProgress cls)
| Increases the current stage of the world generation with one. More...

## Variables
static constexpr NWidgetPart | _nested_generate_landscape_widgets []
| Widgets of GenerateLandscapeWindow when generating world.
static constexpr NWidgetPart | _nested_heightmap_load_widgets []
| Widgets of GenerateLandscapeWindow when loading heightmap.
static const StringID | _elevations [] = {STR_TERRAIN_TYPE_VERY_FLAT, STR_TERRAIN_TYPE_FLAT, STR_TERRAIN_TYPE_HILLY, STR_TERRAIN_TYPE_MOUNTAINOUS, STR_TERRAIN_TYPE_ALPINIST, STR_TERRAIN_TYPE_CUSTOM, INVALID_STRING_ID}
static const StringID | _sea_lakes [] = {STR_SEA_LEVEL_VERY_LOW, STR_SEA_LEVEL_LOW, STR_SEA_LEVEL_MEDIUM, STR_SEA_LEVEL_HIGH, STR_SEA_LEVEL_CUSTOM, INVALID_STRING_ID}
static const StringID | _rivers [] = {STR_RIVERS_NONE, STR_RIVERS_FEW, STR_RIVERS_MODERATE, STR_RIVERS_LOT, INVALID_STRING_ID}
static const StringID | _smoothness [] = {STR_CONFIG_SETTING_ROUGHNESS_OF_TERRAIN_VERY_SMOOTH, STR_CONFIG_SETTING_ROUGHNESS_OF_TERRAIN_SMOOTH, STR_CONFIG_SETTING_ROUGHNESS_OF_TERRAIN_ROUGH, STR_CONFIG_SETTING_ROUGHNESS_OF_TERRAIN_VERY_ROUGH, INVALID_STRING_ID}
static const StringID | _rotation [] = {STR_CONFIG_SETTING_HEIGHTMAP_ROTATION_COUNTER_CLOCKWISE, STR_CONFIG_SETTING_HEIGHTMAP_ROTATION_CLOCKWISE, INVALID_STRING_ID}
static const StringID | _num_towns [] = {STR_NUM_VERY_LOW, STR_NUM_LOW, STR_NUM_NORMAL, STR_NUM_HIGH, STR_NUM_CUSTOM, INVALID_STRING_ID}
static const StringID | _num_inds [] = {STR_FUNDING_ONLY, STR_MINIMAL, STR_NUM_VERY_LOW, STR_NUM_LOW, STR_NUM_NORMAL, STR_NUM_HIGH, STR_NUM_CUSTOM, INVALID_STRING_ID}
static const StringID | _variety [] = {STR_VARIETY_NONE, STR_VARIETY_VERY_LOW, STR_VARIETY_LOW, STR_VARIETY_MEDIUM, STR_VARIETY_HIGH, STR_VARIETY_VERY_HIGH, INVALID_STRING_ID}
static WindowDesc | _generate_landscape_desc (__FILE__, __LINE__, WDP_CENTER, nullptr, 0, 0, WC_GENERATE_LANDSCAPE, WC_NONE, 0, std::begin(_nested_generate_landscape_widgets), std::end(_nested_generate_landscape_widgets))
static WindowDesc | _heightmap_load_desc (__FILE__, __LINE__, WDP_CENTER, nullptr, 0, 0, WC_GENERATE_LANDSCAPE, WC_NONE, 0, std::begin(_nested_heightmap_load_widgets), std::end(_nested_heightmap_load_widgets))
static constexpr NWidgetPart | _nested_create_scenario_widgets []
static WindowDesc | _create_scenario_desc (__FILE__, __LINE__, WDP_CENTER, nullptr, 0, 0, WC_GENERATE_LANDSCAPE, WC_NONE, 0, std::begin(_nested_create_scenario_widgets), std::end(_nested_create_scenario_widgets))
static constexpr NWidgetPart | _nested_generate_progress_widgets []
static WindowDesc | _generate_progress_desc (__FILE__, __LINE__, WDP_CENTER, nullptr, 0, 0, WC_MODAL_PROGRESS, WC_NONE, 0, std::begin(_nested_generate_progress_widgets), std::end(_nested_generate_progress_widgets))
static GenWorldStatus | _gws
static const StringID | _generation_class_table []

## Detailed Description

GUI to configure and show progress during map generation.

Definition in file genworld_gui.cpp.

## Enumeration Type Documentation

## ◆ GenerateLandscapeWindowMode

enum GenerateLandscapeWindowMode

Enum for the modes we can generate in.

Enumerator
GLWM_GENERATE | Generate new game.
GLWM_HEIGHTMAP | Load from heightmap.
GLWM_SCENARIO | Generate flat land.

Definition at line 45 of file genworld_gui.cpp.

## Function Documentation

## ◆ IncreaseGeneratingWorldProgress()

void IncreaseGeneratingWorldProgress | ( | GenWorldProgress | cls | ) |

Increases the current stage of the world generation with one.

Parameters

  cls | the current class we are in.

Warning: this function isn't clever. Don't go from class 4 to 3. Go upwards, always. Also, progress works if total is zero, total works if progress is zero.

Definition at line 1550 of file genworld_gui.cpp.

Referenced by CreateRivers(), and GenerateTerrainPerlin().

## ◆ SetGeneratingWorldProgress()

void SetGeneratingWorldProgress | ( | GenWorldProgress | cls,
|  | uint | total
| ) |  |

Set the total of a stage of the world generation.

Parameters

  cls | the current class we are in.
  total | Set the total expected items for this class.

Warning: this function isn't clever. Don't go from class 4 to 3. Go upwards, always. Also, progress works if total is zero, total works if progress is zero.

Definition at line 1536 of file genworld_gui.cpp.

Referenced by CreateRivers().

## ◆ SetNewLandscapeType()

void SetNewLandscapeType | ( | byte | landscape | ) |

Changes landscape type and sets genworld window dirty.

Parameters

  landscape | new landscape type

Definition at line 64 of file genworld_gui.cpp.

References _settings_newgame, GameSettings::game_creation, InvalidateWindowClassesData(), GameCreationSettings::landscape, WC_GENERATE_LANDSCAPE, and WC_SELECT_GAME.

Referenced by GenerateLandscapeWindow::OnClick().

## ◆ StartNewGameWithoutGUI()

void StartNewGameWithoutGUI | ( | uint32_t | seed | ) |

Start a normal game without the GUI.

Parameters

  seed | The seed of the new game.

Definition at line 1069 of file genworld_gui.cpp.

References _settings_newgame, GameSettings::game_creation, and GameCreationSettings::generation_seed.

Referenced by VideoDriver_Dedicated::MainLoop().

## Variable Documentation

## ◆ _generation_class_table

const StringID _generation_class_table[]
| static

Initial value:
= {
STR_GENERATION_WORLD_GENERATION,
STR_SCENEDIT_TOOLBAR_LANDSCAPE_GENERATION,
STR_GENERATION_RIVER_GENERATION,
STR_GENERATION_CLEARING_TILES,
STR_SCENEDIT_TOOLBAR_TOWN_GENERATION,
STR_SCENEDIT_TOOLBAR_INDUSTRY_GENERATION,
STR_GENERATION_OBJECT_GENERATION,
STR_GENERATION_TREE_GENERATION,
STR_GENERATION_SETTINGUP_GAME,
STR_GENERATION_PREPARING_TILELOOP,
STR_GENERATION_PREPARING_SCRIPT,
STR_GENERATION_PREPARING_GAME
}

Definition at line 1359 of file genworld_gui.cpp.

## ◆ _nested_generate_progress_widgets

constexpr NWidgetPart _nested_generate_progress_widgets[]
| staticconstexpr

Initial value:
= {
NWidget(WWT_CAPTION, COLOUR_GREY), SetDataTip(STR_GENERATION_WORLD, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
NWidget(WWT_PANEL, COLOUR_GREY),
NWidget(NWID_VERTICAL), SetPIP(0, WidgetDimensions::unscaled.vsep_wide, 0), SetPadding(WidgetDimensions::unscaled.modalpopup),
NWidget(WWT_EMPTY, INVALID_COLOUR, WID_GP_PROGRESS_BAR), SetFill(1, 0),
NWidget(WWT_EMPTY, INVALID_COLOUR, WID_GP_PROGRESS_TEXT), SetFill(1, 0),
NWidget(WWT_TEXTBTN, COLOUR_WHITE, WID_GP_ABORT), SetDataTip(STR_GENERATION_ABORT, STR_NULL), SetFill(1, 0),
EndContainer(),
EndContainer(),
}

Definition at line 1330 of file genworld_gui.cpp.

SetFill
constexpr NWidgetPart SetFill(uint16_t fill_x, uint16_t fill_y)
Widget part function for setting filling.
Definition: widget_type.h:1141
WWT_CAPTION
@ WWT_CAPTION
Window caption (window title between closebox and stickybox)
Definition: widget_type.h:63
EndContainer
constexpr NWidgetPart EndContainer()
Widget part function for denoting the end of a container (horizontal, vertical, WWT_FRAME,...
Definition: widget_type.h:1151
WWT_EMPTY
@ WWT_EMPTY
Empty widget, place holder to reserve space in widget tree.
Definition: widget_type.h:50
SetPadding
constexpr NWidgetPart SetPadding(uint8_t top, uint8_t right, uint8_t bottom, uint8_t left)
Widget part function for setting additional space around a widget.
Definition: widget_type.h:1188
WID_GP_PROGRESS_BAR
@ WID_GP_PROGRESS_BAR
Progress bar.
Definition: genworld_widget.h:91
NWidget
constexpr NWidgetPart NWidget(WidgetType tp, Colours col, WidgetID idx=-1)
Widget part function for starting a new 'real' widget.
Definition: widget_type.h:1258
NWID_VERTICAL
@ NWID_VERTICAL
Vertical container.
Definition: widget_type.h:79
WidgetDimensions::unscaled
static const WidgetDimensions unscaled
Unscaled widget dimensions.
Definition: window_gui.h:67
WID_GP_ABORT
@ WID_GP_ABORT
Abort button.
Definition: genworld_widget.h:93
SetPIP
constexpr NWidgetPart SetPIP(uint8_t pre, uint8_t inter, uint8_t post)
Widget part function for setting a pre/inter/post spaces.
Definition: widget_type.h:1220
WWT_PANEL
@ WWT_PANEL
Simple depressed panel.
Definition: widget_type.h:52
SetDataTip
constexpr NWidgetPart SetDataTip(uint32_t data, StringID tip)
Widget part function for setting the data and tooltip.
Definition: widget_type.h:1162
WID_GP_PROGRESS_TEXT
@ WID_GP_PROGRESS_TEXT
Text with the progress bar.
Definition: genworld_widget.h:92
WWT_TEXTBTN
@ WWT_TEXTBTN
(Toggle) Button with text
Definition: widget_type.h:57